
/*
 * Copyright (c) 2006 Jon Siddle <jon@trapdoor.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

//#define dprintf(...) fprintf(stderr, __VA_ARGS__)
#define dprintf(...)

#define SWAP(x,i,j) {char t = ((char *)x)[(i)];\
    ((char *)x)[(i)]=((char *)x)[(j)];\
    ((char *)x)[(j)]=t;}

#define SWAP_16(x) SWAP((x),0,1)
#define SWAP_24(x) SWAP((x),0,2)

#define SWAP_32(x) SWAP((x),0,3); SWAP((x),1,2)

#define ALIGN_DOWN(ptr, size) ( (ptr) / (size) * (size) )
#define ALIGN_UP(ptr, size)   ( ((ptr) + (size) - 1) / (size) * (size) )

enum sample_format {
	S16_BE,		// FD-4,FD-8,VF160
	S24_LE		// D2424
};

enum fdmsfs_pathtype {
    pt_invalid, pt_root, pt_program, pt_track
};

struct fdmsfs_segment {
	unsigned long offset;
	unsigned long length;
};

struct fdmsfs_track {
	int present;
	unsigned long long length;
	int refs;
	struct fdmsfs_segment *segments;
};

struct fdmsfs_prg {
	unsigned long offset;
	int present;
	char name[16];
	struct fdmsfs_track tracks[24];
};

struct fdmsfs {
	int fd;
	int prg_count;
	unsigned long sample_rate;
	int sample_format;
	int sample_size;
	int output_size;
	off_t dev_size;
	struct fdmsfs_prg prgs[128];
} fdmsfs;

struct fdmsfs_fh {
	int prg;
	int trk;
	char *buffer;
	off_t pos;
};
